set polar
set grid polar
set size square
set xrang [0.0 : 22.]
set yrang [0.0 : 22.] 
#rangos inicial y final de lo que se desea, aqui es
#vel.

#si la primera columna esta en grados

set xtics (0,8.0,20.0)
#set rtics (0,5,10,15,20) 
set ytics (0,0,8.0,16.0,20.0)

set angles degrees

set xlabel "1000/Q (x)" 
set ylabel "1000/Q (z)"

color1="red"
color2="royalblue"
color3="black"
color4="magenta"

set style line 11 lt 1 lw 2 pt 2 ps 2 #set the line style for the plot
plot[0:pi/2]'qpbk_inv.angle' w lp pt 6 ps 1 lw 1 linecolor rgb color2 title 'qP waves, SPBM analytical',\
'qp_FE_inv.angle' w lp lw 2  linecolor rgb color4  title 'qP waves, 2PBM elastic, numerical'
#si hay un valor por grado.
set term postscript  enhanced color solid  linewidth 2.0 "Helvetica" 18
set output "Fig26-Q-qP-2ph-har-50Hz-sro-0--srw-0-045-sn1-0-01-sn2-0-1.eps"
replot
set output
