set polar
set grid polar
set size square
set xrang [0.0 : 22.]
set yrang [0.0 : 22.] 
#rangos inicial y final de lo que se desea, aqui es
#vel.

#si la primera columna esta en grados

set xtics (0,7.0,14.0,21.0)
#set rtics (0,5,10,15,20) 
set ytics (0,0,7.0,14.0,21.0)

set angles degrees

set xlabel "1000/Q (x)" 
set ylabel "1000/Q (z)"

color1="red"
color2="royalblue"
color3="black"
color4="green"
color5="magenta"
color6="violet"


set style line 11 lt 1 lw 2 pt 2 ps 2 #set the line style for the plot
# Para poner el nombre de la curva se coloca title 'el nombre que se quiere' después de la palabra title.
plot[0:pi/2]'qp_FE_inv.angle_1ph' w lp  pt 6 ps 1.5 lw 1 linecolor rgb color1 title 'qP waves, SPBM, numerical patchy',\
'qp_FE_inv.angle'w lp pt 8 ps 1.5 lw 1  linecolor rgb color2 title 'qP waves, 2PBM, numerical patchy',\
'qs_FE_inv.angle_1ph' w lp ps 1.5 linecolor rgb color4   title 'qSV waves, SPBM, numerical patchy',\
'qs_FE_inv.angle' w lp pt 4 ps 1.5 lw 1  linecolor rgb color3  title 'qSV waves, 2PBM, numerical patchy'
set term postscript  enhanced color solid  linewidth 2.0 "Helvetica" 18
#set terminal postscript enhanced color solid eps
set output "Fig17-6-4-patchy-Q-qP-qSV-2ph-1ph-har-50Hz.eps"
replot
set output
