      PROGRAM Backus_validation_frequency_angle

      include 'sizes'

      character zz*100
      integer nfrec,nmat,mat_type,nfwork
      real*8 fmin,fmax,fwork,lado,h,deltap
      complex*16 aim
      integer i,j,k,nx,ny
	 
! ---- Viscoelastic parameters

      integer nl(mnmat)
      real*8  rho(mnmat),dl(mnmat) 
      real*8 ks(mnmat),ros(mnmat),km(mnmat),mum(mnmat),phi(mnmat),
     . cappa(mnmat),rof(mnmat),kf(mnmat),eta(mnmat),struc(mnmat)	 
      real*8 angle,rad,freq,psi1,psi2,psi3
      real*8 Qpbk,Vpbk,Vpebk,Qsbk,Vsbk,Vsebk,Qshbk,Vshbk,Vshebk
      real*8 vp_eq,vpe_eq,vs_eq,vse_eq,vsh_eq,vshe_eq,qp_eq,qs_eq,qsh_eq
      Real*8 s,c,co2,c2,s2,sc2,dens
      real*8 vp_qP_eq,ve_qP_eq,vp_qSV_eq,ve_qSV_eq
      real*8 vp_sh_eq,ve_SH_eq
      real*8 ve_qP_bk,ve_qSV_bk,ve_SH_bk
      integer theta
	Real*8 Re_p11,Re_p33,Re_p13,Re_p55,Re_p66
      Real*8 Im_p11,Im_p33,Im_p13,Im_p55,Im_p66
	Real*8 Re_p11a,Re_p33a,Re_p13a,Re_p55a,Re_p66a
      Real*8 Im_p11a,Im_p33a,Im_p13a,Im_p55a,Im_p66a
	Real*8 Re_eps,Im_eps,Re_eps11,Im_eps11,Re_eps33,Im_eps33  
      Real*8 vpex_eq,vpez_eq,vsex_eq,vsez_eq,vshex_eq,vshez_eq
	Real*8 vpexbk,vpezbk,vsexbk,vsezbk,vshexbk,vshezbk	 
!	Complex*16 em,v1,v2,v2sh,p11,p33,p13,p55,p66,eps11,eps33
!      Complex*16 p11bk,p33bk,p55bk,p66bk,p13bk,sig
!      Complex*16 p11work,p33work,p55work,p66work,p13work
      complex*16 p55,p66,p55bk,p66bk,p55work,p66work
      Complex*16 em,v1,v2,v2sh,p11,p33,p13,eps11,eps33
      Complex*16 p11bk,p33bk,p13bk,sig
      Complex*16 p11work,p33work,p13work
	complex*16 vv1,vv1h,bb1,bbb
	complex*16 denom,vv2,beta,xi,W,X,Z,p1,p2
	complex*16 D,al1,al2
       	real*8 an1,an2,an3,en1,en2,en3
! Anisotropic parameters

      complex*16 p11_l(mnmat),p33_l(mnmat),p13_l(mnmat),p55_l(mnmat)
     .          ,p66_l(mnmat)
	real*8 eps(mnmat),gam(mnmat),del(mnmat),alpha0(mnmat),beta0(mnmat)


   30 FORMAT (15F32.17)
   31 FORMAT ('Frequency(Hz)   VqP_eq(km/s)    VqP_backus(km/s)
     .    VqPe_eq(km/s)      VqPe_backus(km/s)    VqSV_eq(km/s)      
     .    VqSV_backus(km/s)   VqSVe_eq(km/s)    VqSVe_backus(km/s)
     .    VSH_eq(km/s)    VSH_backus(km/s)   VSHe_eq(km/s)    
     .    VSHe_backus(m/s)')     
   32 FORMAT ('Frequency(Hz)   InvQqP_eq    InvQqP_backus    InvQqSV_eq    
     .    InvQqSV_backus    InvQSH_eq    InvQSH_backus')  
   34 FORMAT ('Frequency(Hz)       Re_bulk_mod      Im_bulk_mod')

   41 FORMAT ('theta(deg)    psi1(deg)   V_qP_x(km/s)    V_qP_z(km/s)
     .    V_qP_x_bac(km/s)   V_qP_z_bac(km/s)    V_qPe_x(km/s)    
     .         V_qPe_z(km/s)    V_qPe_x_bac(km/s)    V_qPe_z_bac(km/s)')     
   42 FORMAT ('theta(deg)    psi2(deg)   V_qSV_x(km/s)    V_qSV_z(km/s)  
     .    V_qSV_x_bac(km/s)   V_qSV_z_bac(km/s)    V_qSVe_x(km/s)         
     .    V_qSVe_z(km/s)     V_qSVe_x_bac(km/s)    V_qSVe_z_bac(km/s)')          
   43 FORMAT ('theta(deg)    psi3(deg)    V_SH_x(km/s)    V_SH_z(km/s)  
     .    V_SH_x_bac(km/s)   V_SH_z_bac(km/s)    V_SHe_x(km/s)         
     .    V_SHe_z(km/s)     V_SHe_x_bac(km/s)    V_SHe_z_bac(km/s)')

   44 FORMAT ('theta(deg)    psi1(deg)   InvQ_qP_x    InvQ_qP_z     
     .    InvQ_qP_x_bac   InvQ_qP_z_bac')  
   45 FORMAT ('theta(deg)    psi2(deg)   psi3(deg)   InvQ_qSV_x    
     .    InvQ_qSV_z   InvQ_qSV_x_bac     InvQ_qSV_z_bac   InvQ_SH_x      
     .    InvQ_SH_z    InvQ_SH_x_bac    InvQ_SH_z_bac')                            

! INPUT files

      open(unit=1,file='p11.freq',status='old')
      open(unit=2,file='p33.freq',status='old')
      open(unit=3,file='p55.freq',status='old')
      open(unit=4,file='p66.freq',status='old')
c      open(unit=5,file='INPUT.txt',status='unknown')

      open(unit=66,file='eps11.freq',status='old')
      open(unit=7,file='eps33.freq',status='old')

! OUTPUT files
	    
      open(unit=8,file='V_equiv.freq',status='unknown')
      open(unit=9,file='Inv_Q_equiv.freq',status='unknown')
      open(unit=10,file='p13.freq',status='unknown') 

      open(unit=12,file='V_qP',status='unknown')
      open(unit=13,file='V_qSV',status='unknown')
      open(unit=14,file='VSH',status='unknown')  
      open(unit=16,file='InvQ_P',status='unknown')
      open(unit=17,file='InvQ_S',status='unknown')
*  Juan change 

      open(unit=40,file='vp_FE.angle',status='unknown')
      open(unit=41,file='Vpbk.angle',status='unknown')
      open(unit=42,file='vs_FE.angle',status='unknown')
      open(unit=43,file='Vsbk.angle',status='unknown')      
      open(unit=44,file='vsh_FE.angle',status='unknown')
      open(unit=45,file='Vshbk.angle',status='unknown')   
      open(unit=46,file='qp_FE_inv.angle',status='unknown')
      open(unit=47,file='qpbk_inv.angle',status='unknown')   
      open(unit=48,file='qs_FE_inv.angle',status='unknown')
      open(unit=49,file='qsbk_inv.angle',status='unknown')
      open(unit=50,file='qsh_FE_inv.angle',status='unknown')
      open(unit=51,file='qshbk_inv.angle',status='unknown') 
      
      open(unit=61,file='ve_qP_FE.angle',status='unknown')
      open(unit=62,file='ve_qSV_FE.angle',status='unknown')   
      open(unit=63,file='ve_SH_FE.angle',status='unknown')
      
      open(unit=64,file='ve_qP_bk.angle',status='unknown')
      open(unit=65,file='ve_qSV_bk.angle',status='unknown')   
      open(unit=67,file='ve_SH_bk.angle',status='unknown')     
      
      
    
      write(8,31)
      write(9,32)
      write(10,34)

      write(12,41)
      write(13,42)
      write(14,43)
      write(16,44)
      write(17,45)
      
      pi=4.d0*datan(1.d0)
       
      twopi = 2.d0*pi      
      aim=dcmplx(0.d0,1.d0)

!ccccccccccccccccccccccccccccccccccccccccccccccccccc

      call readata(fmin,fmax,fwork,angle,nx,ny,nmat,dl,ks,
     .              ros,km,mum,phi,cappa,struc,rof,kf,eta,h)

      rho(1)=(1.d0-phi(1))*ros(1)+phi(1)*rof(1)
      rho(2)=(1.d0-phi(2))*ros(2)+phi(2)*rof(2)

c      dens=(rho(1)*dl(1)+rho(2)*dl(2))/(dl(1)+dl(2))
c	dens=2230.15481

         dens = 2088.48932    ! taken from the output file pf the pij
         
        print*,'dens=',dens
	print*,'angle (deg)=',angle
	print*,''
	 
     
      read(1,*) 
      read(2,*) 
      read(3,*) 
      read(4,*) 
      read(66,*) 
	read(7,*)     

! ***************************************************************
!       FREQUENCY LOOP
! Here we compute the moduli only at the working frequency fwork
! **************************************************************

!      do ii=1,nfrec

! read p11,p33,p55,p66 and eps11,eps33

      read(1,*) freq,Re_p11,Re_p11a,Im_p11,Im_p11a
	read(2,*) freq,Re_p33,Re_p33a,Im_p33,Im_p33a
!      read(3,*) freq,Re_p55,Re_p55a,Im_p55,Im_p55a
!      read(4,*) freq,Re_p66,Re_p66a,Im_p66,Im_p66a
      read(3,*) freq,Re_p55,Re_p55a,Im_p55,Im_p55a
      read(4,*) freq,Re_p66,Re_p66a,Im_p66,Im_p66a
      read(66,*) freq,Re_eps11,Im_eps11
      read(7,*) freq,Re_eps33,Im_eps33

! Compute p13 using numerical results

	p11=(Re_p11+aim*Im_p11) 
	p33=(Re_p33+aim*Im_p33) 
	p55=(Re_p55+aim*Im_p55) 
      p66=(Re_p66+aim*Im_p66)
      eps11=(Re_eps11+aim*Im_eps11)
      eps33=(Re_eps33+aim*Im_eps33)

	p13=(eps11*p11-eps33*p33)/(eps11-eps33)

! Save moduli at the working frequency for polar curves

!	IF (ii.eq.nfwork) THEN

	   fwork=freq
	   p11work=p11
	   p33work=p33
	   p55work=p55
	   p66work=p66
         p13work=p13

      print*,'working frequency (Hz)=',fwork
      print*,''
      print*,'numerical at working frequency'
      print*,''
	print*,'p11=',p11
      print*,'p33=',p33
	print*,'p13=',p13
	print*,'p55=',p55
      print*,'p66=',p66
      print*,''
      print*, 'eps11=',eps11
       print*,'eps33=',eps33    
       

!	ENDIF

! ----------------- Compute Quality factors and Velocities using numerical results -------------

      CALL VQanis(angle,dens,p11,p33,p55,p66,p13,psi1,psi2,psi3,
     .    vp_eq,vpex_eq,vpez_eq,vs_eq,vsex_eq,vsez_eq,vsh_eq,vshex_eq,
     .    vshez_eq,qp_eq,qs_eq,qsh_eq)

      vpe_eq=sqrt(vpex_eq**2+vpez_eq**2)      ! qP-wave energy velocity
      vse_eq=sqrt(vsex_eq**2+vsez_eq**2)      !  qSV-wave energy velocity
      vshe_eq=sqrt(vshex_eq**2+vshez_eq**2)   !  SH-wave energy velocity	 

! --- Compute Shapiro-Gelinsky local properties

      CALL ShapiroG(freq,mum,km,ks,ros,kf,rof,cappa,eta,phi,dl,
     .  p11bk,p33bk,p13bk,p55bk,p66bk)

!	print*,'ii,p66,p66bk=',ii,p66,p66bk

! ----------------- Compute Quality factors and Velocities using Backus results -------------

      CALL VQanis(angle,dens,p11bk,p33bk,p55bk,p66bk,p13bk,psi1,psi2,
     .    psi3,vpbk,vpexbk,vpezbk,vsbk,vsexbk,vsezbk,vshbk,vshexbk,
     .    vshezbk,qpbk,qsbk,qshbk)

      vpebk=sqrt(vpexbk**2+vpezbk**2)      ! qP-wave energy velocity
      vsebk=sqrt(vsexbk**2+vsezbk**2)      !  qSV-wave energy velocity
      vshebk=sqrt(vshexbk**2+vshezbk**2)   !  SH-wave energy velocity	 

! ----- Write results on files
	 
      write(8,30)freq,vp_eq,Vpbk,vpe_eq,Vpebk
     .               ,vs_eq,Vsbk,vse_eq,Vsebk
     .	           ,vsh_eq,Vshbk,vshe_eq,Vshebk
      write(9,30)freq,1./qp_eq,1./Qpbk,1./qs_eq,1./Qsbk,
     .                1./qsh_eq,1./Qshbk
      write(10,30)freq,dreal(p13),dimag(p13)                      

!      enddo

! --- Compute Shapiro-Gelinsky local properties at working frequency

      CALL ShapiroG(fwork,mum,km,ks,ros,kf,rof,cappa,eta,phi,dl,
     .  p11bk,p33bk,p13bk,p55bk,p66bk)

      print*,'analytical at working frequency'
      print*,''
	print*,'p11bk=',p11bk
      print*,'p33bk=',p33bk
	print*,'p13bk=',p13bk
	print*,'p55bk=',p55bk
      print*,'p66bk=',p66bk

	read(*,'(a)') zz
        
! ***************************************************************
!       ANGLE LOOP
! ***************************************************************

      do theta=0,90,3

	angle=theta

	If (angle.eq.0.) THEN 
	   angle=0.1
	ENDIF
      If (angle.eq.90.) THEN 
	   angle=89.9
	ENDIF

	print*,'angle (deg)=',angle

!      compute polar curves using numerical moduli

      CALL VQanis(angle,dens,p11work,p33work,p55work,p66work,
     .    p13work,psi1,psi2,psi3,vp_eq,vpex_eq,vpez_eq,vs_eq,vsex_eq,
     .    vsez_eq,vsh_eq,vshex_eq,vshez_eq,qp_eq,qs_eq,qsh_eq)

      rad=angle*pi/180

      vpx_eq=vp_eq*sin(rad)
      vpz_eq=vp_eq*cos(rad)
      vsx_eq=vs_eq*sin(rad)
      vsz_eq=vs_eq*cos(rad)
      vshx_eq=vsh_eq*sin(rad)
      vshz_eq=vsh_eq*cos(rad)
      
      vpe_eq=sqrt(vpex_eq**2+vpez_eq**2)      ! qP-wave energy velocity
      vse_eq=sqrt(vsex_eq**2+vsez_eq**2)      !  qSV-wave energy velocity
      vshe_eq=sqrt(vshex_eq**2+vshez_eq**2)   !  SH-wave energy velocity	 
      ve_qP_eq=sqrt(vpex_eq**2+vpez_eq**2)      ! qP-wave energy velocity
      ve_qSV_eq=sqrt(vsex_eq**2+vsez_eq**2)      !  qSV-wave energy velocity
      ve_SH_eq=sqrt(vshex_eq**2+vshez_eq**2) 
      
! --- Plot Q's in function of the energy angles

!      qpx_eq=1.d3/qp_eq*sin(psi1)
!      qpz_eq=1.d3/qp_eq*cos(psi1)
!      qsx_eq=1.d3/qs_eq*sin(psi2)
!      qsz_eq=1.d3/qs_eq*cos(psi2)
!      qshx_eq=1.d3/qsh_eq*sin(psi3)
!      qshz_eq=1.d3/qsh_eq*cos(psi3)

! --- Plot Q's in function of the phase angles

      qpx_eq=1.d3/qp_eq*sin(rad)
      qpz_eq=1.d3/qp_eq*cos(rad)
      qsx_eq=1.d3/qs_eq*sin(rad)
      qsz_eq=1.d3/qs_eq*cos(rad)
      qshx_eq=1.d3/qsh_eq*sin(rad)
      qshz_eq=1.d3/qsh_eq*cos(rad)

!      compute polar curves using Backus moduli  

      CALL VQanis(angle,dens,p11bk,p33bk,p55bk,p66bk,p13bk,psi1,psi2,
     .    psi3,vpbk,vpexbk,vpezbk,vsbk,vsexbk,vsezbk,vshbk,vshexbk,
     .    vshezbk,qpbk,qsbk,qshbk)

      vpxbk=vpbk*sin(rad)
      vpzbk=vpbk*cos(rad)
      vsxbk=vsbk*sin(rad)
      vszbk=vsbk*cos(rad)
      vshxbk=vshbk*sin(rad)
      vshzbk=vshbk*cos(rad)
      
      vpebk=sqrt(vpexbk**2+vpezbk**2)      ! qP-wave energy velocity
      vsebk=sqrt(vsexbk**2+vsezbk**2)      !  qSV-wave energy velocity
      vshebk=sqrt(vshexbk**2+vshezbk**2)   !  SH-wave energy velocity
      
      ve_qP_bk=sqrt(vpexbk**2+vpezbk**2)      ! qP-wave energy velocity
      ve_qSV_bk=sqrt(vsexbk**2+vsezbk**2)      !  qSV-wave energy velocity
      ve_SH_bk=sqrt(vshexbk**2+vshezbk**2)   !  SH-wave energy velocity	     
! --- Plot Q's in function of the energy angles

!      qpxbk=1.d3/qpbk*sin(psi1)
!      qpzbk=1.d3/qpbk*cos(psi1)
!      qsxbk=1.d3/qsbk*sin(psi2)
!      qszbk=1.d3/qsbk*cos(psi2)
!      qshxbk=1.d3/qshbk*sin(psi3)
!      qshzbk=1.d3/qshbk*cos(psi3)

! --- Plot Q's in function of the phase angles

      qpxbk=1.d3/qpbk*sin(rad)
      qpzbk=1.d3/qpbk*cos(rad)
      qsxbk=1.d3/qsbk*sin(rad)
      qszbk=1.d3/qsbk*cos(rad)
      qshxbk=1.d3/qshbk*sin(rad)
      qshzbk=1.d3/qshbk*cos(rad)

! ----- Write polar curves on files
	 
      write(12,30)angle,psi1*180/pi,vpx_eq,vpz_eq,vpxbk,vpzbk,
     .                vpex_eq,vpez_eq,vpexbk,vpezbk
      write(13,30)angle,psi2*180/pi,vsx_eq,vsz_eq,vsxbk,vszbk,
     . vsex_eq,vsez_eq,vsexbk,vsezbk
      write(14,30)angle,psi3*180/pi,vshx_eq,vshz_eq,vshxbk,vshzbk,
     . vshex_eq,vshez_eq,vshexbk,vshezbk
      write(16,30)angle,psi1*180/pi,qpx_eq,qpz_eq,qpxbk,qpzbk
      write(17,30)angle,psi2*180/pi,psi3*180/pi,qsx_eq,qsz_eq,qsxbk,
     .                qszbk,qshx_eq,qshz_eq,qshxbk,qshzbk
  
  
c        angle1 = 89.9d0 -angle
c         angle1 = angle
        
        if(angle.lt.0.d0) angle1  = 0.1
       
  
  
     
        write(40,123)angle,vp_eq

       write(41,123)angle,Vpbk
       write(42,123)angle,vs_eq
       write(43,123)angle,Vsbk
       write(44,123)angle,vsh_eq
       write(45,123)angle,Vshbk      
      
       write(46,123)angle,1.d3/qp_eq
       write(47,123)angle,1.d3/Qpbk
       write(48,123)angle,1.d3/qs_eq
       write(49,123)angle,1.d3/Qsbk
       write(50,123)angle,1.d3/qsh_eq
       write(51,123)angle,1.d3/Qshbk          
123    format(2g20.8)

       rad=180./pi
       
        an1=rad*atan(vpez_eq/vpex_eq)
        an2=rad*atan(vsez_eq/vsex_eq)
        an3=rad*atan(vshez_eq/vshex_eq)
        
       vpe_eq=sqrt(vpex_eq**2+vpez_eq**2)      ! qP-wave energy velocity
       vse_eq=sqrt(vsex_eq**2+vsez_eq**2)      !  qSV-wave energy velocity
       vshe_eq=sqrt(vshex_eq**2+vshez_eq**2)   !  SH-wave energy velocity
       
       
       
 
       
c       en1=sqrt(vpex_eq*vpex_eq+ vpez_eq * vpez_eq )
c        en2=sqrt(vsex_eq*vsex_eq+ vsez_eq * vsez_eq )
c        en3=sqrt(vshex_eq*vshex_eq+ vshez_eq * vshez_eq ) 

      write(61,123)an1,vpe_eq
      write(62,123)an2,vse_eq
      write(63,123)an3,vshe_eq
      
         an1=rad*atan(vpezbk/vpexbk)
        an2=rad*atan(vsezbk/vsexbk)
        an3=rad*atan(vshezbk/vshexbk)
        
      ve_qP_bk=sqrt(vpexbk**2+vpezbk**2)      ! qP-wave energy velocity
      ve_qSV_bk=sqrt(vsexbk**2+vsezbk**2)      !  qSV-wave energy velocity
      ve_SH_bk=sqrt(vshexbk**2+vshezbk**2)   !  SH-wave energy velocity	   
      
      write(64,123)an1,ve_qP_bk
      write(65,123)an2,ve_qSV_bk
      write(67,123)an3,ve_SH_bk       
      
	enddo

	stop
	end

! *********************************************************************


      SUBROUTINE VQanis(angle,dens,p11,p33,p55,p66,p13,psi1,psi2,psi3,
     .            vp,vpex,vpez,vs,vsex,vsez,vsh,vshex,vshez,qp,qs,qsh) 

      include 'sizes'

      real*8 aqq1,c1,c1e,aqq2,cc2,c2e,aqq2sh,c2sh,c2esh
      real*8 qf1x,qf1z                       
      real*8 qf2x,qf2z
	real*8 dens,angle                   
      real*8 c1x,c1z                 
      real*8 c2x,c2z                 
      real*8 c1ex,c1ez,theta,psi1,psi2,psi3            
      real*8 c2ex,c2ez
	real*8 vp,vpex,vpez,vs,vsex,vsez,vsh,vshex,vshez,qp,qs,qsh       
!	complex*16 p11,p33,p13,p55,p66
      complex*16 p55,p66
      complex*16 p11,p33,p13
	complex*16 em,v1,vv1,vv1h,bb1,bbb,v2,v2sh
	complex*16 denom,vv2,beta,xi,W,X,Z,p1,p2
	complex*16 D,al1,al2
	complex*16 s1,s3

!c theta measured from vertical axis

      pi=4.d0*datan(1.d0)
       
      twopi = 2.d0*pi      
      aim=dcmplx(0.d0,1.d0)

      theta=angle*pi/180
!*                                                                               
       s=sin(theta)                                                            
       c=cos(theta)  
       co2=cos(2.*theta)
       c2=c*c                                                                   
       s2=s*s                                                                   
       sc2=s2*c2                                                                
!*                                                                               
!*      Phase velocity and quality factor                                                          
!*      ----------------------------------                                                           
!*                                                                               
       em=((p11-p55)*s*s+(p55-p33)*c*c)**2+4.*(p13+p55)*                
     .     (p13+p55)*s*s*c*c                                                  
       em=sqrt(em)                                                            
       v1=sqrt(p55+p11*s*s+p33*c*c+em)/sqrt(2.*dens)                      
       v2=sqrt(p55+p11*s*s+p33*c*c-em)/sqrt(2.*dens)
	 v2sh=sqrt(p66*s*s+p55*c*c)/sqrt(dens)   	                       
       vp=1./dreal(1/v1)   
       qp=dreal(v1*v1)/dimag(v1*v1)	
       vs=1./dreal(1/v2)   
       qs=dreal(v2*v2)/dimag(v2*v2)	  	     
       vsh=1./dreal(1./v2sh)  
	 qsh=dreal(v2sh*v2sh)/dimag(v2sh*v2sh)         

!*                                                                               
!*      Energy velocity                                                          
!*      ---------------                           q                               

!c ! qP-wave energy velocity

       bbb=p11*s**2-p33*c**2+p55*co2
	 beta=SQRT(em+bbb)
	 xi=SQRT(em-bbb)

       W=p55*(xi*s+beta*c)
       X=beta*p11*s+xi*p13*c
       Z=beta*p13*s+xi*p33*c

       p1=conjg(beta)*X+conjg(xi)*W
       p2=conjg(beta)*W+conjg(xi)*Z
       tp=dreal(p1)/dreal(p2)
       psi1=atan(tp)

       vpex=vp/(s+c/tp)
       vpez=vp/(s*tp+c) 

! Formulation for inhomogeneous waves

!      s1=s/v1
!	s3=c/v1

!	beta=SQRT((p55*s1**2+p33*s3**2-dens)/
!     .          (p11*s1**2+p33*s3**2+p55*(s1**2+s3**2)-2*dens))
!	xi=SQRT((p11*s1**2+p55*s3**2-dens)/
!     .          (p11*s1**2+p33*s3**2+p55*(s1**2+s3**2)-2*dens))
!	 W=p55*(xi*s1+beta*s3)
!       X=beta*p11*s1+xi*p13*s3
!       Z=beta*p13*s1+xi*p33*s3

!       vpex=1./Real(s1+s3/tp)
!       vpez=1./Real(s1*tp+s3)
      
!	 print *,'c1,c1e=',c1,c1e


!c qSV-wave energy velocity

       bbb=p11*s**2-p33*c**2+p55*co2
	 beta=SQRT(em-bbb)
	 xi=-SQRT(em+bbb)  

       W=p55*(xi*s+beta*c)
       X=beta*p11*s+xi*p13*c
       Z=beta*p13*s+xi*p33*c

       p1=conjg(beta)*X+conjg(xi)*W
       p2=conjg(beta)*W+conjg(xi)*Z
       tp=dreal(p1)/dreal(p2)
       psi2=atan(tp)

       vsex=vs/(s+c/tp)
       vsez=vs/(s*tp+c) 

! Formulation for inhomogeneous waves

!      s1=s/v2
!	s3=c/v2

!	beta=SQRT((p55*s1**2+p33*s3**2-dens)/
!     .          (p11*s1**2+p33*s3**2+p55*(s1**2+s3**2)-2*dens))
!	xi=-SQRT((p11*s1**2+p55*s3**2-dens)/
!     .          (p11*s1**2+p33*s3**2+p55*(s1**2+s3**2)-2*dens))
!	 W=p55*(xi*s1+beta*s3)
!       X=beta*p11*s1+xi*p13*s3
!       Z=beta*p13*s1+xi*p33*s3

!       vsex=1./Real(s1+s3/tp)
!       vsez=1./Real(s1*tp+s3) 

!	 print*,'cc2,c2e=',cc2,c2e


! Formulation from Carcione (1992)

!       vv1=p11*s2+p55*c2-dens*v2*v2                                            
!       vv1h=-vv1/(p13+p55)                                                    
!       bb1=vv1h/c/s                                                             
!       abb1=abs(bb1)**2                                                       
!       de11=dens*(1.+abb1)*real(v2)  
!	 print *,'vv1,vv1h,bb1=',vv1,vv1h,bb1                                          
!       c2ex=vs_eq*real((p11*s+p13*bb1*c+p55*(conjg(bb1)                 
!     .          *c+abb1*s))/v2)/de11                                           
!       c2ez=vs_eq*real((p33*c*abb1+p13*conjg(bb1)*s+p55*(c+             
!     .          bb1*s))/v2)/de11
!       vse=sqrt(c2ex**2+c2ez**2)   !  energy velocity
!	 print*,'cc2,c2e=',cc2,c2e

! SH-wave energy velocity

       psi3=atan(dReal(p66/v2sh)*tan(theta)/dReal(p55/v2sh))
       vshex=(vsh/(dens*dreal(v2sh)))*s*dreal(p66/v2sh)                                       
       vshez=(vsh/(dens*dreal(v2sh)))*c*dreal(p55/v2sh)

      return 

	end 

!************************************************************************

      subroutine readata(fmin,fmax,fwork,angle,nx,ny,nmat,dl,ks,
     .              ros,km,mum,phi,cappa,struc,rof,kf,eta,h)

      include 'sizes'
      real*8 ks(mnmat),ros(mnmat),km(mnmat),mum(mnmat),phi(mnmat),
     . cappa(mnmat),rof(mnmat),kf(mnmat),eta(mnmat),struc(mnmat)
      real*8 roo(mnmat),ko(mnmat),etao(mnmat)
      real*8 row(mnmat),kw(mnmat),etaw(mnmat),sat_nw(mnmat)         
      integer scale,nx,nmat,nl(mnmat)
      real*8 pi,twopi,h,fmin,fmax,lado,fwork,angle,dl(mnmat)
       pi = 4.d0*datan(1.d0)
       twopi = 2.d0*pi

      read(5,*)fmin
      read(5,*)fmax
      read(5,*)fwork
      read(5,*)angle
      read(5,*)lado
      read(5,*)nx
      read(5,*)ny
      read(5,*)nmat

!      print*,fmin
!      print*,fmax
!      print*,scale
!      print*,h
!      print*,nx
!      print*,ny
!      print*,nmat

!	read(*,'(a)') zz

!* reads material properties for each material type
      
      do i=1,nmat
      read(5,*)nl(i)
      read(5,*)ks(i)
      read(5,*)ros(i)
      read(5,*)km(i)
      read(5,*)mum(i)
      read(5,*)phi(i)
      read(5,*)cappa(i)
      read(5,*)struc(i)
      read(5,*)roo(i)
      read(5,*)row(i)      
      read(5,*)ko(i)
      read(5,*)kw(i)     
      read(5,*)etao(i)
      read(5,*)etaw(i)
      
      read(5,*)sat_nw(i)     
      
      print*,nl(i)
      print*,ks(i)
      print*,ros(i)
      print*,km(i)
      print*,mum(i)
      print*,phi(i)
      print*,cappa(i)
      print*,' roo(i)  ', roo(i)
      print*,' row(i)  ', row(i)     
      print*,' ko(i)   ',  ko(i)
      print*,'kw(i)    ',  kw(i)     
      print*,'etao(i)  ',etao(i) 
      print*,'etaw(i)  ',etaw(i)      
      
c      read(5,*)rof(i)
c      read(5,*)kf(i)
c      read(5,*)eta(i)

!      print*,nl(i)
!      print*,ks(i)
!      print*,ros(i)
!      print*,km(i)
!      print*,mum(i)
!      print*,phi(i)
!      print*,cappa(i)
!      print*,rof(i)
!      print*,kf(i)
!      print*,eta(i)

!	read(*,'(a)') zz

      enddo
c   reads  but not uses this data      
c      read(5,*)amplit
c      read(5,*)sro
c      read(5,*)srw
c      read(5,*)knowet
c      read(5,*)grav
c      read(5,*)p_conf     
c      read(5,*)grad
c      read(5,*)t_s
c      read(5,*)rho_av 
c      read(5,*)pwbar
c      read(5,*)epsi
c      lado=h*ny
       h = lado/ny

	dl(1)=h*nl(1)    ! size first layer
	dl(2)=h*nl(2)    ! size second layer
      
           do  44 i=1,nmat
          
          so = sat_nw(i)

          sw = 1.d0-so 
          aux= so /ko(i) + sw /kw(i)

         kf(i) = 1.d0/aux
         
         rof(i) = so *roo(i) + sw *row(i)             
         eta(i) = so* etao(i) + sw* etaw(i)
         
         write(6,*)' i, so,kf(i) ', i, so,kf(i)
         
          write(6,*)' i, so,rof(i) ', i, so,rof(i)
          write(6,*)' i, so,eta(i) ', i, so,eta(i)
          
    
 44      continue          
      return
      end

!**********************************************************************************************************
!**************************************************************************

!************************************************************************
c
c Gelinsky-Shapiro
c
!************************************************************************

      SUBROUTINE ShapiroG(ff,mum,km,Ks,rs,Kf,rf,k,eta,phi,d,
     .  p11,p33,p13,p55,p66)

       implicit real*8 (a-h,o-z)
       real*8 mum(2),km(2),lm(2),Ks(2),Kf(2),M(2),K(2),d(2)
       real*8 phi(2),Em(2),rs(2),rf(2),al(2),eta(2),p(2)
       real*8 ff
       complex*16 a1,a2,fac,aI1,aI2,E,ai
       complex*16 arg1,arg2,cot1,cot2,v
       complex*16 p11,p33,p13,p12,p55,p66
c
       complex*16 am11,am12,am13,am33,am55,am66
       complex*16 v1,v2,v3,vv1,vv2,vv1h,vv2h
       complex*16 bb1,bb2
       real*8 x1,x2,x3,x4,x5,x6
c
c cIJ
       f=1.e+9
       fq=1.e+3
       ai=(0.,1.)
       pi=3.14159265

c 
       d12=d(1)+d(2)
       p(1)=d(1)/d12
       p(2)=1.-p(1)

       lm(1)=km(1)-2.*mum(1)/3.
       Em(1)=lm(1)+2.*mum(1)
       al(1)=1.-Km(1)/Ks(1) 
       M(1)=1./((al(1)-phi(1))/Ks(1)+phi(1)/Kf(1))

       lm(2)=km(2)-2.*mum(2)/3.
       Em(2)=lm(2)+2.*mum(2)
       al(2)=1.-Km(2)/Ks(2) 
       M(2)=1./((al(2)-phi(2))/Ks(2)+phi(2)/Kf(2))

       s1=0.
       s2=0.
       s3=0.
       s4=0.
       s5=0.
       s6=0.
       s7=0.
       s8=0.
       s9=0.
       s10=0.
       do i=1,2
       s1=s1+p(i)/Em(i)
       s2=s2+p(i)*al(i)/Em(i)
       s3=s3+p(i)/M(i)
       s4=s4+p(i)*al(i)*al(i)/Em(i)
       s5=s5+mum(i)*p(i)
       s6=s6+p(i)*lm(i)*mum(i)/Em(i)
       s7=s7+p(i)*al(i)*mum(i)/Em(i)
       s8=s8+p(i)*lm(i)/Em(i)
       s9=s9+p(i)/mum(i)
       EG=Em(i)+al(i)*al(i)*M(i)
       s10=s10+p(i)*EG/M(i)/Em(i)
       end do
c Relaxed
c
       B8=1./(s3+s4-s2**2/s1)
       B7=-B8*s2/s1
       B6=-B8*(2.*s7+s2*s8/s1)
       c33r=1./s1+B7*B7/B8        ! Wrong equation from G-S
       c33r=1./(s1-s2*s2/s10)     ! Corrected version
       c66r=s5
       c12r=2.*s6+s8**2/s1+B6**2/B8
       c11r=c12r+2.*c66r
       c13r=s8/s1+B6*B7/B8
       c55r=1./s9
c
c
c unrelaxed
c
       s1=0.
       s2=0.
       s3=0.
       s4=0.
       s5=0.
       s6=0.
       do i=1,2
       EG=Em(i)+al(i)*al(i)*M(i)
       s1=s1+p(i)/EG
       s2=s2+p(i)*(EG-2.*mum(i))*mum(i)/EG
       s3=s3+p(i)*(EG-2.*mum(i))/EG
       s5=s5+p(i)/al(i)/M(i)
c      s6=s6+p(i)*M(i)
       s6=s6+p(i)/M(i)
       end do
c
       c66=c66r
       c55=c55r
       c12=2.*s2+s3*s3/s1
       c13=s3/s1
       c33=1./s1
       c11=c12+2.*c66
       B6=1./s5
       B7=B6
       B8=s6
       B8=1./s6
c
c
c White check for p33
c layered model    
c geometry


c composite density
       rho1=rs(1)*(1.-phi(1))+phi(1)*rf(1)
       rho2=rs(2)*(1.-phi(2))+phi(2)*rf(2)
       rho=rho1*p(1)+rho2*p(2)
c
       akG1=Km(1)+al(1)*al(1)*M(1)
       akG2=Km(2)+al(2)*al(2)*M(2)
	 EG1=akG1+4.*mum(1)/3.
	 EG2=akG2+4.*mum(2)/3.
	 alp1=al(1)
	 alp2=al(2)
	 t2=1.-phi(1)-Km(1)/Ks(1)+phi(1)*Ks(1)/Kf(1)
	 aM1=Ks(1)/t2
	 t2=1.-phi(2)-Km(2)/Ks(2)+phi(2)*Ks(2)/Kf(2)
	 aM2=Ks(2)/t2
         r1=alp1*M(1)/EG1
         r2=alp2*M(2)/EG2
	 aKE1=M(1)*Em(1)/EG1
	 aKE2=M(2)*Em(2)/EG2
       E0=p(1)/EG1+p(2)/EG2
       E0=1./E0
c
       b=0.5*d12
       w0=4.*k(1)*aKE1/eta(1)/b/b
	 
! --- Frequency
      
       om=2.*pi*ff 
c
       a1=ai*om*eta(1)/k(1)/aKE1
       a1=sqrt(a1)
       a2=ai*om*eta(2)/k(2)/aKE2
       a2=sqrt(a2)
       arg1=0.5*a1*d(1)
       arg2=0.5*a2*d(2)
       cot1=(exp(arg1)+exp(-arg1))/(exp(arg1)-exp(-arg1))
       cot2=(exp(arg2)+exp(-arg2))/(exp(arg2)-exp(-arg2))
       aI1=(eta(1)/k(1)/a1)*cot1
       aI2=(eta(2)/k(2)/a2)*cot2
       fac=ai*om*d12*(aI1+aI2)
       E=1./E0+2.*(r2-r1)**2/fac
       p33=1./E

       p11=c11+(c11-c11r)*(p33-c33)/(c33-c33r)
       p12=c12+(c12-c12r)*(p33-c33)/(c33-c33r)
       p13=c13+(c13-c13r)*(p33-c33)/(c33-c33r)

       p55=c55
       p66=c66

       q11=fq*dimag(p11)/dreal(p11)
       q111=dreal(p11)/dimag(p11)
       q333=dreal(p33)/dimag(p33)
       q12=fq*dimag(p12)/dreal(p12)
       q13=fq*dimag(p13)/dreal(p13)
       q33=fq*dimag(p33)/dreal(p33)

!       q55=fq*dimag(p55)/dreal(p55)
!       q66=fq*dimag(p66)/dreal(p66)

c       
       v=sqrt(p11/rho)
       v11=1./dreal(1./v)
       v=sqrt(p33/rho)
       v33=1./dreal(1./v)
       v=sqrt(p55/rho)
       v55=1./dreal(1./v)
       v=sqrt(p66/rho)
       v66=1./dreal(1./v)

c      write(2,*),sngl(fr),sngl(q11),sngl(q12),sngl(q13),sngl(q33)
c       write(2,*),sngl(fr),sngl(q11),sngl(q33)
c       write(3,*),sngl(fr),sngl(v11),sngl(v33)
c      print *,i,ff(i),sngl(q11),sngl(q33)
c       print *,i,ff(i),sngl(q111),sngl(q333)
c      print *,i,ff(i),sngl(v11),sngl(v33)

c
       RETURN
       end
