set polar
set grid polar
set size square
set xrang [0.0 : 4300.0]
set yrang [0.0 : 4300.0]

# Importante, aquí para que no se superpongan los numeros en el eje X, toca darle unos valores al xtics y otros al rtics.
set xtics (500,1500,2500,3500)
#set rtics (0,500,1000,1500,2000,2500) 
set ytics (0, 500 ,1500, 2500,3500)

set angles degrees


set xlabel "Ve_x(m/s)" 
set ylabel "Ve_z(m/s)"

color1="red"
color2="royalblue"
color3="black"
color4="green"

set style line 11 lt 1 lw 2 pt 2 ps 2 #set the line style for the plot
# Para poner el nombre de la curva se coloca title 'el nombre que se quiere' después de la palabra title.
plot[-pi/2:pi/2] 've_qP_bk.angle' w lp  pt 6 ps 1.5 lw 1 linecolor rgb color1 title 'qP waves, SPBM,  analytical'
set term postscript  enhanced color solid  linewidth 2.0 "Helvetica" 18
#set terminal postscript enhanced color solid eps
set output "fi2.eps"
replot
set output
