set polar
set grid polar
set size square
set xrang [0.0 : 25.0]
set yrang [0.0 : 25.0] 
#rangos inicial y final de lo que se desea, aqui es
#vel.
set angles degrees
#si la primera columna esta en grados

set xtics (5,10,15,20)
#set rtics (0,3,5,7) 
set ytics (0, 5, 10 ,15,20,25)

set xlabel "1000/Q (x)" 
set ylabel "1000/Q (z)"

color1="red"
color2="royalblue"

color3="black"
color4="magenta"

plot[0:pi/2] 'qpbk_inv.angle' w lp pt 6 ps 1 lw 1 linecolor rgb color1 title 'qP waves, SPBM, analytical',\
'qp_FE_inv.angle' w lp  pt 8 ps 1 lw 1  linecolor rgb color2  title 'qP waves, 2PBM, numerical',\
'qsbk_inv.angle' w lp lw 2  linecolor rgb color4  title 'qSV waves, SPBM, analytical',\
'qs_FE_inv.angle' w lp pt 4 ps 1 lw 1  linecolor rgb color3   title 'qSV waves, 2PBM, numerical'
#si hay un valor por grado.
set term postscript  enhanced color solid  linewidth 2.0 "Helvetica" 18
set output 'Figure6-validation-Q-qP_qSV-2phase-and-analytical-50Hz-sro-0-0-srw-0-01-sn1-0-01-sn2-0-1.eps'
replot
set output
#
# w lp pt 6 ps 1 lw 1 linecolor rgb color1   :red circle

# w lp  pt 8 ps 1 lw 1  linecolor rgb color2 : royalblue triangle 

#   w lp lw 2  linecolor rgb color4  :    star magenta     

# w lp pt 4 ps 1 lw 1  linecolor rgb color3   : square green  

#plot xp(t), yp(t) w l lt 3  
#set style line 1 lc rgb 'black' pt 5   # square
#set style line 2 lc rgb 'black' pt 7   # circle
#set style line 3 lc rgb 'black' pt 9   # triangle
#linestyle va de 1 a 12
#grafica solo el que tiene ';'
#plot "double.data" using 1:2 title "Series 1", "double.data" using 1:3 title "Series 2"
#plot[0:pi/2] 'venerg_qP_xy.angle' ';' pt 5,'venerg_qSV_xy.angle' w l
#with lines  (w l) se unen los puntos con líneas rectas
#with points  (w p) se marcan sólo los puntos
#with linespoints  (w lp) se marcan los puntos y se unen con lineas rectas
#linewidth k  (lw k) determina el grosor de la línea
#linetype n  (lt n) determina el tipo de línea, lo que a su vez determina el color
#si se deja un blanco entre los datos de entrada, solo se grafican puntos.
#en gnuplot tipear test
