set polar
set grid polar
set size square
set xrang [0.0 : 2500.0]
set yrang [0.0 : 2500.0]

# Importante, aquí para que no se superpongan los numeros en el eje X, toca darle unos valores al xtics y otros al rtics.
#set xtics (500,1000,2500)
#set rtics (0,500,1000,1500,2000,2500) 
#set ytics (0, 500 ,1500, 2500,3500)

set angles degrees


set xlabel "Ve_x(m/s)" 
set ylabel "Ve_z(m/s)"

color1="red"
color2="royalblue"
color3="black"
color4="green"
color5="magenta"
color6="violet"

set style line 11 lt 1 lw 2 pt 2 ps 2 #set the line style for the plot
# Para poner el nombre de la curva se coloca title 'el nombre que se quiere' después de la palabra title.
plot[0:pi/2] 've_qSV_bk.angle_8_2' w lp  pt 6 ps 1.5 lw 1 linecolor rgb color1 title '20% kerogen SPBM,  analytical',\
've_qSV_FE.angle_8_2' w lp pt 8 ps 1.5 lw 1  linecolor rgb color2  title '20% kerogen 2PBM, numerical',\
've_qSV_bk.angle_7_3' w lp ps 1.5 linecolor rgb color4  title '30% kerogen SPBM, analytical',\
've_qSV_FE.angle_7_3' w lp pt 4 ps 1.5 lw 1  linecolor rgb color3   title '30% kerogen 2PBM, numerical'
set term postscript  enhanced color solid  linewidth 2.0 "Helvetica" 18
#set terminal postscript enhanced color solid eps
set output "Fig12-8_2_7-3-ve-qSV-2ph-har-and-ana-50Hz-sro-0-srw-0-1-sn1-0-01-sn2-0-1.eps"
replot
set output
