set polar
set grid polar
set size square
set xrang [0.0 : 20.]
set yrang [0.0 : 20.] 
#rangos inicial y final de lo que se desea, aqui es
#vel.

#si la primera columna esta en grados

#set xtics (0,7.0,14.0,21.0)
#set rtics (0,5,10,15,20) 
#set ytics (0,0,7.0,14.0,21.0)

set angles degrees

set xlabel "1000/Q (x)" 
set ylabel "1000/Q (z)"

color1="red"
color2="royalblue"
color3="black"
color4="green"
color5="magenta"
color6="violet"

set style line 11 lt 1 lw 2 pt 2 ps 2 #set the line style for the plot
plot[0:pi/2]'qpbk_inv.angle_8_2' w lp pt 6 ps 1 lw 1 linecolor rgb color1 title '20% kerogen SPBM analytical',\
'qp_FE_inv.angle_8_2' w lp lw 2  linecolor rgb color2  title '20% kerogen 2PBM, numerical',\
'qpbk_inv.angle_7_3' w lp pt 6 ps 1 lw 1 linecolor rgb color4 title '30% kerogen SPBM analytical',\
'qp_FE_inv.angle_7_3' w lp lw 2  linecolor rgb color3  title '30% kerogen 2PBM, numerical'
#si hay un valor por grado.
set term postscript  enhanced color solid  linewidth 2.0 "Helvetica" 18
set output "Fig13-8_2_7-3-validation-Q-qP-2ph-har-50Hz-sro-0--srw-0-1-sn1-0-01-sn2-0-1.eps"
replot
set output
