set polar
set grid polar
set size square
set xrang [0.0 : 4.]
set yrang [0.0 : 4.] 
#rangos inicial y final de lo que se desea, aqui es
#vel.

#si la primera columna esta en grados

set xtics (0,1.,2.,3.,4.)
#set rtics (0,5,10,15,20) 
set ytics (0,1.,2.,3.,4.)

set angles degrees

set xlabel "1000/Q (x)" 
set ylabel "1000/Q (z)"

color1="red"
color2="royalblue"
color3="black"
color4="green"
color5="magenta"
color6="violet"

set style line 11 lt 1 lw 2 pt 2 ps 2 #set the line style for the plot
plot[0:pi/2]'qsbk_inv.angle_8_2' w lp pt 6 ps 1 lw 1 linecolor rgb color1 title '20% kerogen SPBM analytical',\
'qs_FE_inv.angle_8_2' w lp lw 2  linecolor rgb color2  title '20% kerogen 2PBM, numerical',\
'qsbk_inv.angle_7_3' w lp pt 6 ps 1 lw 1 linecolor rgb color4 title '30% kerogen SPBM analytical',\
'qs_FE_inv.angle_7_3' w lp lw 2  linecolor rgb color3  title '30% kerogen 2PBM, numerical'
#si hay un valor por grado.
set term postscript  enhanced color solid  linewidth 2.0 "Helvetica" 18
set output "Fig14-8-2-7-3-Q-qSV-2ph-har-ana-50Hz-sro-0--srw-0-1-sn1-0-01-sn2-0-1.eps"
replot
set output
