set polar
set grid polar
set size square
set xrang [0.0 : 18.]
set yrang [0.0 : 18.] 
#rangos inicial y final de lo que se desea, aqui es
#vel.

#si la primera columna esta en grados

set xtics (0,6.,12.,18.)
#set rtics (0,5,10,15,20) 
set ytics (0,6.,12.,18.)

set angles degrees

set xlabel "1000/Q (x)" 
set ylabel "1000/Q (z)"

color1="red"
color2="royalblue"
color3="black"
color4="magenta"

set style line 11 lt 1 lw 2 pt 2 ps 2 #set the line style for the plot
plot[0:pi/2]'qs_FE_inv.angle_vali' w lp pt 6 ps 1 lw 1 linecolor rgb color2 title 'qSV, uniform 10 % gas in kerogen ',\
'qs_FE_inv.angle_6_4_patchy' w lp lw 2  linecolor rgb color4  title 'qSV, patchy 10 % gas in kerogen'
#si hay un valor por grado.
set term postscript  enhanced color solid  linewidth 2.0 "Helvetica" 18
set output "Fig22-6-4-validation-and-patchy-10gas-in-kerogen-Q-qP-2PBM-50Hz-sro-0-srw-0-1.eps"
replot
set output
